// Note - this .prg requires the following library:
//       Telepathy


#include "inkey.ch"

STATIC oBr
STATIC nComPort

FUNCTION main(cParam)
  LOCAL nRow    := ROW()
  LOCAL nCol    := COL()
  LOCAL cScreen := SAVESCREEN(0, 0, MAXROW(), MAXCOL() )
  
  IF VALTYPE(cParam)=="C" .AND. (nComPort:=VAL(cParam)) > 0 .AND. tp_open(nComPort, , ,9600)==0
    *** Yeah! ***
  ELSE
    
    DO CASE
      CASE tp_open(1, , ,9600)==0
        nComPort := 1
        
      CASE tp_open(2, , ,9600)==0
        nComPort := 2
        
      OTHERWISE
        @10,10 SAY "Sorry could not open com1 or com2..."
        TONE(300,10)
        nComPort := 0
        INKEY(0)
    ENDCASE
  ENDIF    

  IF nComPort > 0
    SETCOLOR("+BG/B")
    CLEAR
    USE Pictures NEW 
    INDEX ON Pictures->Lastname TO Pictures
    LoadBrowse()
    
    SET CURSOR OFF
    KeyProcess()
    SET CURSOR ON
  ENDIF
  
  tp_close()
  
  CLOSE DATABASES
  RESTSCREEN(0, 0, MAXROW(), MAXCOL(), cScreen)
  SET COLOR TO
  DEVPOS(nRow, nCol)
RETURN(NIL)

***********
* Function: LoadBrowse()
* Author..: Troy Henikoff
* Date....: 10/17/92
* Notes...: Create & loads a TBrowse object
* Returns.: NIL
***********

FUNCTION LoadBrowse()
  
  SETCOLOR("+BG/N")
  oBr       := TBrowseDB(3, 23, 21, 65 )         && Generic DBF skipper included already
  oBr:AddColumn(TBColumnNew("", {|| PAD(TRIM(Pictures->Lastname)+", "+Pictures->Firstnam,40) } )) &&   assign it a single column
  @ 1, 0 SAY PADC('BROWSE OF PICTURES', 80 ) COLOR "+GR/B"
RETURN(NIL)


***********
* Function: KeyProcess
* Author..: Troy Henikoff
* Date....: 10/17/92
* Notes...: Processes keystrokes for a TBrowse
*
* Params..: none
*
* Returns.: NIL
***********

FUNCTION KeyProcess()
  LOCAL nKey                                     && Key that the user presses
  
  DO WHILE .T.
    nKey := 0                                    && Reset value of nKey
    
    *** stabilize the display (standard TBrowse stuff) ***
    DO WHILE .NOT. oBr:stabilize()               && DO while the display is not stabilized, incrementally stabilize it.
      nKey := INKEY()                            &&   check to see if the user has pressed a key
      IF nKey <> 0                               &&   IF a key was pressed
        EXIT                                     &&     EXIT out of this loop and process the user's request
      ENDIF                                      &&   ENDIF
    ENDDO                                        && ENDDO - go back and stabilize it a little more...
    
    *** This part is needed for multiuser applications to ensure that we are displaying the most current version of the data ***
    IF nKey == 0                                 && IF we disable caching AND the browse was completely re-drawn without a user request
      oBr:RefreshCurrent()                       &&   mark that the "Current" line needs to be refreshed
      DO WHILE .NOT. oBr:stabilize()             &&   re-draw (hopefully just 1 line)
      ENDDO                                      &&   no need to check keyboard etc.
    ENDIF                                        && ENDIF
    
    IF oBr:stable .AND. nKey==0                  && IF the display is stable
      tp_send(nComPort, PAD(Pictures->PcxFile,30))
      nKey := INKEY(0)                           &&   Wait forever for the user to hit a key
    ENDIF                                        && ENDIF
    
    *** Finally, we get to process the key that was pressed ***
    DO CASE
      CASE nKey == K_DOWN
        oBr:down()
        
      CASE nKey == K_UP
        oBr:up()
        
      CASE nKey == K_PGDN
        oBr:pageDown()
        
      CASE nKey == K_PGUP
        oBr:pageUp()
        
      CASE nKey == K_ESC
        EXIT
        
    ENDCASE
  ENDDO
RETURN(NIL)

